local invoke_service = {}
local json = require("json")
local utils = require("utils")
local utils_device = require("utils_device")

function invoke_service.invoke_service(pk, dn, service_name, args)

    --FIXME: should follow new message style
    utils.check_pk(pk)
    utils.check_dn(dn)
   
    if service_name == nil then 
        return false, "service name is not correct", "iot.error" 
    end

    local ret_success, ret_msg, ret_code, ret_data
    local params = {}
    local args_json = json.decode(args)

    for _, item in ipairs(args_json) do
        params[item["key"]] = item["value"]
    end

    ret_success, ret_data = utils_device.call_service(pk, dn, service_name, args_json) 

    if ret_success == false then
        ret_msg = "failed to call service: "..ret_data
        ret_code = ""
    end

    return ret_success, ret_msg, ret_code, ret_data
end

return invoke_service

