local set_device_property = {}
local json = require("json")
local utils = require("utils")
local utils_device = require("utils_device")


function set_device_property.set_property(pk, dn, property_list)
    local new_property = ""
   
    utils.check_pk(pk)
    utils.check_dn(dn)
   
    if property_list == nil then
        return false, "property list is not correct", "iot.error" 
    end
    
    local args_json = json.decode(property_list)
    for k, v in pairs(args_json) do
        new_property = new_property.."\""..k.."\":"..v..","
    end
    new_property = string.sub(new_property, 1, #new_property - 1) 
    
    ret = utils_device.set_property_value(pk, dn, new_property)
    if (not ret) then
        return false, "set data into device failed", "iot.error"
    end

    return true, "", "", ""
end

return set_device_property

